Index: libs/libmythtv/programinfo.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythtv/libs/libmythtv/programinfo.cpp,v
retrieving revision 1.107
diff -u -r1.107 programinfo.cpp
--- libs/libmythtv/programinfo.cpp	7 Feb 2004 01:19:54 -0000	1.107
+++ libs/libmythtv/programinfo.cpp	8 Feb 2004 21:30:44 -0000
@@ -44,9 +44,9 @@
     dupin = kDupsInAll;
     dupmethod = kDupCheckSubDesc;
 
-    sourceid = -1;
-    inputid = -1;
-    cardid = -1;
+    sourceid = 0;
+    inputid = 0;
+    cardid = 0;
     schedulerid = "";
     recpriority = 0;
     recgroup = QObject::tr("Default");
@@ -845,7 +845,7 @@
     if (chanid == other.chanid &&
         startts < other.endts &&
         endts > other.startts &&
-        (sourceid == -1 || other.sourceid == -1 ||
+        (sourceid <= 0 || other.sourceid <= 0 ||
          sourceid == other.sourceid))
         return true;
     return false;
Index: programs/mythbackend/main.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythtv/programs/mythbackend/main.cpp,v
retrieving revision 1.57
diff -u -r1.57 main.cpp
--- programs/mythbackend/main.cpp	6 Feb 2004 23:45:05 -0000	1.57
+++ programs/mythbackend/main.cpp	8 Feb 2004 21:30:44 -0000
@@ -388,12 +388,14 @@
     if (printsched)
     {
         sched = new Scheduler(false, &tvList, db);
+#if 1
         if (gContext->ConnectToMasterServer())
         {
             cout << "Retrieving Schedule from Master backend.\n";
             sched->FillRecordListFromMaster();
         }
         else
+#endif
         {
             cout << "Calculating Schedule from database.\n" <<
                     "Inputs, Card IDs, and Conflict info may be invalid "
@@ -401,7 +403,7 @@
             sched->FillRecordLists(false);
         }
 
-        sched->PrintList(true);
+        sched->PrintList();
         cleanup();
         exit(0);
     }
Index: programs/mythbackend/mainserver.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythtv/programs/mythbackend/mainserver.cpp,v
retrieving revision 1.124
diff -u -r1.124 mainserver.cpp
--- programs/mythbackend/mainserver.cpp	6 Feb 2004 06:36:30 -0000	1.124
+++ programs/mythbackend/mainserver.cpp	8 Feb 2004 21:30:45 -0000
@@ -927,7 +927,7 @@
             {
                 (*encoderList)[num]->StopRecording();
                 pginfo->recstatus = rsStopped;
-                m_sched->AddToDontRecord(pginfo);
+                m_sched->UpdateRecStatus(pginfo);
             }
 
             if (pbssock)
@@ -963,7 +963,7 @@
             if (ismaster)
             {
                 pginfo->recstatus = rsStopped;
-                m_sched->AddToDontRecord(pginfo);
+                m_sched->UpdateRecStatus(pginfo);
             }
         }
     }
@@ -1085,7 +1085,7 @@
            {
                (*encoderList)[num]->StopRecording();
                pginfo->recstatus = rsDeleted;
-               m_sched->AddToDontRecord(pginfo);
+               m_sched->UpdateRecStatus(pginfo);
            }
 
            if (pbssock)
@@ -1121,7 +1121,7 @@
             if (ismaster)
             {
                 pginfo->recstatus = rsDeleted;
-                m_sched->AddToDontRecord(pginfo);
+                m_sched->UpdateRecStatus(pginfo);
             }
         }
     }
Index: programs/mythbackend/scheduler.cpp
===================================================================
RCS file: /var/lib/mythcvs/mythtv/programs/mythbackend/scheduler.cpp,v
retrieving revision 1.73
diff -u -r1.73 scheduler.cpp
--- programs/mythbackend/scheduler.cpp	6 Feb 2004 23:45:05 -0000	1.73
+++ programs/mythbackend/scheduler.cpp	8 Feb 2004 21:30:45 -0000
@@ -147,6 +147,11 @@
     return ScheduledRecording::hasChanged(db);
 }
 
+static inline bool Recording(ProgramInfo *p)
+{
+    return (p->recstatus == rsRecording || p->recstatus == rsWillRecord);
+}
+
 class comp_proginfo 
 {
   public:
@@ -173,35 +178,19 @@
 
     QMutexLocker lockit(recordingList_lock);
 
-    while (recordingList.size() > 0)
-    {
-        ProgramInfo *pginfo = recordingList.back();
-        delete pginfo;
-        recordingList.pop_back();
-    }
-
-    PruneDontRecords();
-
-    findAllProgramsToRecord(recordingList);
+    QDateTime now = QDateTime::currentDateTime();
 
-    QMap<QString, bool> foundlist;
+    PruneRecordList(now);
 
-    list<ProgramInfo *>::iterator iter = recordingList.begin();
-    for (; iter != recordingList.end(); iter++)
-    {
-        ProgramInfo *pginfo = (*iter);
-        pginfo->schedulerid = pginfo->startts.toString() + "_" + pginfo->chanid;
-
-        foundlist[pginfo->schedulerid] = true;
-    }
+    AddFuturePrograms(now);
 
     if (recordingList.size() > 0)
     {
         recordingList.sort(comp_proginfo());
-        MarkKnownInputs();
         PruneOverlaps();
+        MarkKnownInputs();
         MarkConflicts();
-        PruneList();
+        PruneList(now);
         MarkConflicts();
 
         if (numcards > 1 || numinputs > 1)
@@ -212,11 +201,7 @@
 
         MarkConflictsToRemove();
         if (doautoconflicts)
-        {
-            //RemoveConflicts();
             GuessConflicts();
-            //RemoveConflicts();
-        }
         MarkConflicts();
     }
 
@@ -245,13 +230,14 @@
     }
 }
 
-void Scheduler::PrintList(bool onlyFutureRecordings)
+void Scheduler::PrintList(void)
 {
     QDateTime now = QDateTime::currentDateTime();
+    QString episode;
 
     cout << "--- print list start ---\n";
     list<ProgramInfo *>::iterator i = recordingList.begin();
-    cout << "Title                 Chan  ChID  StartTime       S I C "
+    cout << "Title                     Chan  ChID Day Start  End   S I C "
             " C R O N Priority" << endl;
 
     for (; i != recordingList.end(); i++)
@@ -263,9 +249,16 @@
              (first->recstartts < now)))
             continue;
 
-        cout << first->title.local8Bit().leftJustify(22, ' ', true)
+        if (first->subtitle > " ")
+            episode = QString("%1 - \"%2\"").arg(first->title.local8Bit())
+                                            .arg(first->subtitle.local8Bit());
+        else
+            episode = first->title.local8Bit();
+
+        cout << episode.leftJustify(26, ' ', true)
              << first->chanstr.rightJustify(4, ' ') << "  " << first->chanid 
-             << first->recstartts.toString("  MMM dd hh:mmap  ")
+             << first->recstartts.toString("  dd hh:mm-")
+             << first->recendts.toString("hh:mm  ")
              << first->sourceid 
              << " " << first->inputid << " " << first->cardid << "  "  
              << first->conflicting << " " << first->recording << " "
@@ -277,51 +270,42 @@
     cout << "---  print list end  ---\n";
 }
 
-void Scheduler::AddToDontRecord(ProgramInfo *pginfo)
+void Scheduler::UpdateRecStatus(ProgramInfo *pginfo)
 {
     QMutexLocker lockit(recordingList_lock);
 
-    QValueList<ProgramInfo>::Iterator dreciter = dontRecordList.begin();
-    for (; dreciter != dontRecordList.end(); ++dreciter)
+    list<ProgramInfo *>::iterator dreciter = recordingList.begin();
+    for (; dreciter != recordingList.end(); ++dreciter)
     {
-        if ((*dreciter).IsSameProgramTimeslot(*pginfo))
+        ProgramInfo *p = *dreciter;
+        if (p->IsSameProgramTimeslot(*pginfo))
         {
-            (*dreciter).recstatus = pginfo->recstatus;
+            p->recstatus = pginfo->recstatus;
             return;
         }
     }
-
-    dontRecordList.append(*pginfo);
 }
 
-void Scheduler::PruneDontRecords(void)
+void Scheduler::PruneRecordList(const QDateTime &now)
 {
-    QDateTime deltime = QDateTime::currentDateTime().addDays(-1);
+    QDateTime deltime = now.addDays(-1);
 
-    QValueList<ProgramInfo>::Iterator dreciter = dontRecordList.begin();
-    while (dreciter != dontRecordList.end())
+    list<ProgramInfo *>::iterator dreciter = recordingList.begin();
+    while (dreciter != recordingList.end())
     {
-        if ((*dreciter).recendts < deltime)
-            dreciter = dontRecordList.remove(dreciter);
+        ProgramInfo *p = *dreciter;
+        if (p->recendts < deltime ||
+            (p->recstatus >= rsWillRecord && p->recstatus != rsCancelled &&
+             p->recstatus != rsLowDiskSpace && p->recstatus != rsTunerBusy))
+        {
+            delete p;
+            dreciter = recordingList.erase(dreciter);
+        }
         else
-            dreciter++;
-    }
-}
-
-void Scheduler::RemoveRecording(ProgramInfo *pginfo)
-{
-    recPendingList.remove(pginfo->schedulerid);
-
-    QMutexLocker lockit(recordingList_lock);
-
-    list<ProgramInfo *>::iterator i = recordingList.begin();
-    for (; i != recordingList.end(); i++)
-    {
-        ProgramInfo *rec = (*i);
-        if (rec == pginfo)
         {
-            recordingList.erase(i);
-            break;
+            if (p->recstatus == rsRecording && p->recendts < now)
+                p->recstatus = rsRecorded;
+            dreciter++;
         }
     }
 }
@@ -343,7 +327,7 @@
     for (; i != recordingList.end(); i++)
     {
         ProgramInfo *first = (*i);
-        if (first->inputid == -1)
+        if (first->inputid <= 0 && first->recstatus == rsWillRecord)
         {
             if (numInputsPerSource[first->sourceid] == 1)
             {
@@ -377,8 +361,9 @@
             ProgramInfo *first = (*i);
             ProgramInfo *second = (*j);
 
-            if (!first->recording || !second->recording)
+            if (!Recording(first) || !Recording(second))
                 continue;
+
             if (Conflict(first, second))
             {
                 first->conflicting = true;
@@ -426,79 +411,50 @@
     }    
 }
 
-void Scheduler::PruneList(void)
+void Scheduler::PruneList(const QDateTime &now)
 {
     list<ProgramInfo *>::reverse_iterator i;
     list<ProgramInfo *>::iterator q;
 
-    QDateTime now = QDateTime::currentDateTime();
-
     q = recordingList.begin();
-    while (q != recordingList.end())
+    for ( ; q != recordingList.end(); q++)
     {
         ProgramInfo *rec = (*q);
 
-        if (!rec->AllowRecordingNewEpisodes(db))
+        if (rec->recstatus == rsWillRecord &&
+            !rec->AllowRecordingNewEpisodes(db))
         {
             rec->recording = false;
             rec->recstatus = rsTooManyRecordings;
         }
-
-        q++;
     }
 
     q = recordingList.begin();
-    while (q != recordingList.end())
+    for ( ; q != recordingList.end(); q++)
     {
         ProgramInfo *rec = (*q);
 
         if (rec->recstartts > now)
             break;
 
-        // check the "don't record" list (deleted programs, already started
-        // conflicting programs, etc.
-
-        QValueList<ProgramInfo>::Iterator dreciter = dontRecordList.begin();
-        for (; dreciter != dontRecordList.end(); ++dreciter)
-        {
-            if ((*dreciter).IsSameProgramTimeslot(*rec))
-            {
-                delete rec;
-                rec = NULL;
-                recordingList.erase(q++);
-                break;
-            }
-        }
-        if (rec == NULL)
-            continue;
-
         QMap<int, EncoderLink *>::Iterator enciter = m_tvList->begin();
         for (; enciter != m_tvList->end(); ++enciter)
         {
             EncoderLink *elink = enciter.data();
             if (elink->isRecording(rec))
             {
-                rec->conflicting = false;
                 rec->recording = true;
                 rec->recstatus = rsRecording;
-                AddToDontRecord(rec);
-                delete rec;
-                rec = NULL;
-                recordingList.erase(q++);
                 break;
             }
         }
-        if (rec == NULL)
-            continue;
-
-        q++;
     }
 
     for (i = recordingList.rbegin(); i != recordingList.rend(); i++)
     {
         ProgramInfo *first = (*i);
 
-        if (!first->recording || first->rectype == kSingleRecord ||
+        if (!Recording(first) || first->rectype == kSingleRecord ||
             (!first->rectype == kFindOneRecord &&
             first->subtitle.length() <= 2 && first->description.length() <= 2))
             continue;
@@ -509,7 +465,7 @@
         {
             ProgramInfo *second = (*j);
 
-            if (!second->recording)
+            if (!Recording(second))
                 continue;
 
             if (first->IsSameProgram(*second))
@@ -517,13 +473,15 @@
                 if (((second->conflicting && !first->conflicting) ||
                      second->recstartts < now.addSecs(-15) || first->override == 1) 
                     && second->override != 1 
-                    && ~second->dupmethod & kDupCheckNone)
+                    && ~second->dupmethod & kDupCheckNone
+                    && second->recstatus != rsRecording)
                 {
                     second->recording = false;
                     second->recstatus = rsOtherShowing;
                 }
                 else if (first->override != 1
-                         && ~first->dupmethod & kDupCheckNone)
+                         && ~first->dupmethod & kDupCheckNone
+                         && first->recstatus != rsRecording)
                 {
                     first->recording = false;
                     first->recstatus = rsOtherShowing;
@@ -546,20 +504,13 @@
 
     QDateTime now = QDateTime::currentDateTime();
 
-    QValueList<ProgramInfo>::Iterator dreciter = dontRecordList.begin();
-    for (; dreciter != dontRecordList.end(); ++dreciter)
-    {
-        if ((*dreciter).recstatus == rsRecording && (*dreciter).recendts < now)
-            (*dreciter).recstatus = rsRecorded;
-        ProgramInfo *newInfo = new ProgramInfo(*dreciter);
-        retList->push_back(newInfo);
-    }
-
     list<ProgramInfo *>::iterator i = recordingList.begin();
     for (; i != recordingList.end(); i++)
     {
-        ProgramInfo *newInfo = new ProgramInfo(*(*i));
-        retList->push_back(newInfo);
+        ProgramInfo *p = *i;
+        if (p->recstatus == rsRecording && p->recendts < now)
+            p->recstatus = rsRecorded;
+        retList->push_back(new ProgramInfo(*p));
     }
 }
 
@@ -568,21 +519,18 @@
     QMutexLocker lockit(recordingList_lock);
 
     (*strList) << QString::number(hasconflicts);
-    (*strList) << QString::number(recordingList.size() + dontRecordList.size());
+    (*strList) << QString::number(recordingList.size());
 
     QDateTime now = QDateTime::currentDateTime();
 
-    QValueList<ProgramInfo>::Iterator dreciter = dontRecordList.begin();
-    for (; dreciter != dontRecordList.end(); ++dreciter)
-    {
-        if ((*dreciter).recstatus == rsRecording && (*dreciter).recendts < now)
-            (*dreciter).recstatus = rsRecorded;
-        (*dreciter).ToStringList(*strList);
-    }
-
     list<ProgramInfo *>::iterator i = recordingList.begin();
     for (; i != recordingList.end(); i++)
-        (*i)->ToStringList(*strList);
+    {
+        ProgramInfo *p = *i;
+        if (p->recstatus == rsRecording && p->recendts < now)
+            p->recstatus = rsRecorded;
+        p->ToStringList(*strList);
+    }
 }
 
 list<ProgramInfo *> *Scheduler::getAllScheduled(void)
@@ -654,7 +602,7 @@
             second->chanid == pginfo->chanid)
             continue;
 
-        if (removenonplaying && (!pginfo->recording || !second->recording))
+        if (removenonplaying && (!Recording(pginfo) || !Recording(second)))
             continue;
         if (Conflict(pginfo, second))
             retlist->push_back(second);
@@ -676,7 +624,8 @@
         if (info->recpriority == second->recpriority)
             continue;
 
-        if (info->recpriority > second->recpriority)
+        if (info->recpriority > second->recpriority
+            && second->recstatus != rsRecording)
         {
             second->recording = false;
             second->recstatus = rsLowerRecPriority;
@@ -691,6 +640,8 @@
 void Scheduler::CheckOverride(ProgramInfo *info,
                               list<ProgramInfo *> *conflictList)
 {
+    int resolved = 0;
+
     QString thequery;
 
     QString starts = info->startts.toString("yyyyMMddhhmm");
@@ -714,10 +665,16 @@
         {
             ProgramInfo *del = (*i);
 
+            if (del->recstatus == rsRecording)
+                continue;
+
             del->recording = false;
             del->recstatus = rsManualConflict;
+            resolved++;
         }
-        info->conflicting = false;
+
+        if (resolved == (int)conflictList->size())
+            info->conflicting = false;
     }
 }
 
@@ -756,7 +713,7 @@
             {
                 ProgramInfo *test = (*i);
                 if (test->chanid == badchannum && test->startts == badst && 
-                    test->endts == badend)
+                    test->endts == badend && test->recstatus != rsRecording)
                 {
                     test->recording = false;
                     test->recstatus = rsManualConflict;
@@ -770,7 +727,7 @@
     for (; i != conflictList->end(); i++)
     {
         ProgramInfo *test = (*i);
-        if (test->recording == true)
+        if (Recording(test) == true)
             conflictsleft = true;
     }
 
@@ -795,7 +752,7 @@
             for (; i != conflictList->end(); i++)
             {
                 ProgramInfo *test = (*i);
-                if (test->title == badtitle)
+                if (test->title == badtitle && test->recstatus != rsRecording)
                 {
                     test->recording = false;
                     test->recstatus = rsManualConflict;
@@ -809,14 +766,12 @@
     for (; i != conflictList->end(); i++)
     {
         ProgramInfo *test = (*i);
-        if (test->recording == true)
+        if (Recording(test) == true)
             conflictsleft = true;
     }
 
     if (!conflictsleft)
-    {
         info->conflicting = false;
-    }
 }
 
 void Scheduler::MarkConflictsToRemove(void)
@@ -830,7 +785,8 @@
         {
             ProgramInfo *first = (*i);
 
-            if (first->conflicting && first->recording)
+            if (first->conflicting && Recording(first) 
+                && first->recstatus != rsRecording)
             {
                 list<ProgramInfo *> *conflictList = getConflicting(first);
                 CheckRecPriority(first, conflictList);
@@ -844,7 +800,8 @@
     {
         ProgramInfo *first = (*i);
     
-        if (first->conflicting && first->recording)
+        if (first->conflicting && Recording(first)
+            && first->recstatus != rsRecording)
         {
             list<ProgramInfo *> *conflictList = getConflicting(first);
             CheckOverride(first, conflictList); 
@@ -857,13 +814,14 @@
     {
         ProgramInfo *first = (*i);
   
-        if (first->conflicting && first->recording)
+        if (first->conflicting && Recording(first)
+            && first->recstatus != rsRecording)
         {
             list<ProgramInfo *> *conflictList = getConflicting(first);
             MarkSingleConflict(first, conflictList);
             delete conflictList;
         }
-        else if (!first->recording)
+        else if (!Recording(first))
             first->conflicting = false;
     }
 
@@ -874,7 +832,8 @@
         {
             ProgramInfo *first = (*i);
 
-            if (first->conflicting && first->recording)
+            if (first->conflicting && Recording(first)
+                && first->recstatus != rsRecording)
             {
                 list<ProgramInfo *> *conflictList = getConflicting(first);
                 CheckRecPriority(first, conflictList);
@@ -884,25 +843,6 @@
     }
 }
 
-void Scheduler::RemoveConflicts(void)
-{
-    list<ProgramInfo *>::iterator del;
-    list<ProgramInfo *>::iterator i = recordingList.begin();
-    while (i != recordingList.end())
-    {
-        ProgramInfo *first = (*i);
-
-        del = i;
-        i++;
-
-        if (!first->recording)
-        {
-            delete first;
-            recordingList.erase(del);
-        }
-    }
-}
-
 ProgramInfo *Scheduler::GetBest(ProgramInfo *info, 
                                 list<ProgramInfo *> *conflictList)
 {
@@ -914,7 +854,7 @@
     {
         ProgramInfo *test = (*i);
         RecordingType testtype = test->GetProgramRecordingStatus(db);
-        if (testtype < type)
+        if (testtype < type || test->recstatus == rsRecording)
         {
             best = test;
             type = testtype;
@@ -981,7 +921,8 @@
     for (; i != recordingList.end(); i++)
     {
         ProgramInfo *first = (*i);
-        if (first->recording && first->conflicting)
+        if (Recording(first) && first->conflicting
+            && first->recstatus != rsRecording)
         {
             list<ProgramInfo *> *conflictList = getConflicting(first, true);
             GuessSingle(first, conflictList);
@@ -1002,7 +943,7 @@
 
         second->conflictfixed = false;
 
-        if (second->cardid <= 0)
+        if (second->cardid <= 0 && second->recstatus == rsWillRecord)
         {
             int numinputs = numInputsPerSource[first->sourceid];
             bool placed = false;
@@ -1081,11 +1022,12 @@
     for (i = copylist->begin(); i != copylist->end(); i++)
     {
         ProgramInfo *first = (*i);
-        if (first->recording && first->conflicting)
+        if (Recording(first) && first->conflicting)
         {
             numconflicts++;
             allConflictList.push_back(first);
-            if (numInputsPerSource[first->sourceid] == 1) 
+            if (numInputsPerSource[first->sourceid] == 1
+                || first->recstatus == rsRecording) 
                 canMoveList.push_back(false);
             else
                 canMoveList.push_back(true);
@@ -1110,7 +1052,9 @@
         {
             ProgramInfo *second = (*j);
 
-            bool secondmove = (numInputsPerSource[second->sourceid] > 1);
+            bool secondmove = 
+                (numInputsPerSource[second->sourceid] > 1 && 
+                 second->recstatus != rsRecording);
 
             if (second->conflictfixed)
                 secondmove = false;
@@ -1275,7 +1219,6 @@
     int prerollseconds = 0;
 
     int secsleft;
-    bool resetIter = false;
     EncoderLink *nexttv = NULL;
 
     ProgramInfo *nextRecording = NULL;
@@ -1286,7 +1229,7 @@
 
     QString recordfileprefix = gContext->GetFilePrefix();
 
-    list<ProgramInfo *>::iterator recIter;
+    list<ProgramInfo *>::iterator startIter = recordingList.begin();
 
     bool blockShutdown = gContext->GetNumSetting("blockSDWUwithoutClient", 1);
     QDateTime idleSince = QDateTime();
@@ -1306,6 +1249,7 @@
         {
             FillEncoderFreeSpaceCache();
             FillRecordLists();
+            startIter = recordingList.begin();
             lastupdate = curtime;
             VERBOSE(VB_GENERAL, "Found changes in the todo list.");
 
@@ -1326,9 +1270,9 @@
             // wakeup call
             if (firstRun && blockShutdown)
             {
-                if ((recIter = recordingList.begin()) != recordingList.end())
+                if ((startIter = recordingList.begin()) != recordingList.end())
                 {
-                    if (curtime.secsTo((*recIter)->startts) - prerollseconds
+                    if (curtime.secsTo((*startIter)->startts) - prerollseconds
                         < idleWaitForRecordingTime * 60)
                     {
                         blockShutdown = false;
@@ -1338,84 +1282,95 @@
             firstRun = false;
         }
 
-        recIter = recordingList.begin();
-        while (recIter != recordingList.end())
+        list<ProgramInfo *>::iterator recIter = startIter;
+        for ( ; recIter != recordingList.end(); recIter++)
         {
-            nextRecording = (*recIter);
+            QString msg;
+
+            nextRecording = *recIter;
+
+            if (nextRecording->recstatus != rsWillRecord)
+            {
+                if (recIter == startIter)
+                    startIter++;
+                continue;
+            }
 
             if (m_tvList->find(nextRecording->cardid) == m_tvList->end())
             {
-                cerr << "invalid cardid " << nextRecording->cardid << endl;
-                exit(0);
+                msg = QString("invalid cardid (%1) for %2")
+                    .arg(nextRecording->cardid)
+                    .arg(nextRecording->title);
+                VERBOSE(VB_GENERAL, msg);
+
+                QMutexLocker lockit(recordingList_lock);
+                nextRecording->conflicting = false;
+                nextRecording->recording = false;
+                nextRecording->recstatus = rsTunerBusy;
+
+                if (recIter == startIter)
+                    startIter++;
+                continue;
             }
+
             nexttv = (*m_tvList)[nextRecording->cardid];
             // cerr << "nexttv = " << nextRecording->cardid;
             // cerr << " title: " << nextRecording->title << endl;
 
-            bool recording = nextRecording->recording;
-
             nextrectime = nextRecording->recstartts;
             secsleft = curtime.secsTo(nextrectime);
 
             if (secsleft - prerollseconds > 35)
                 break;
 
-            if (recording && nexttv->isLowOnFreeSpace())
+            if (nexttv->isLowOnFreeSpace())
             {
                 FillEncoderFreeSpaceCache();
                 if (nexttv->isLowOnFreeSpace())
                 {
-                    QString msg = QString("SUPPRESSED recording '%1' on channel"
-                                          " %2 on cardid %3, sourceid %4.  Only"
-                                          " %5 Megs of disk space available.")
-                                          .arg(nextRecording->title)
-                                          .arg(nextRecording->chanid)
-                                          .arg(nextRecording->cardid)
-                                          .arg(nextRecording->sourceid)
-                                          .arg(nexttv->getFreeSpace());
-
+                    msg = QString("SUPPRESSED recording '%1' on channel"
+                                  " %2 on cardid %3, sourceid %4.  Only"
+                                  " %5 Megs of disk space available.")
+                        .arg(nextRecording->title)
+                        .arg(nextRecording->chanid)
+                        .arg(nextRecording->cardid)
+                        .arg(nextRecording->sourceid)
+                        .arg(nexttv->getFreeSpace());
                     VERBOSE(VB_GENERAL, msg);
 
                     QMutexLocker lockit(recordingList_lock);
-
                     nextRecording->conflicting = false;
                     nextRecording->recording = false;
                     nextRecording->recstatus = rsLowDiskSpace;
-                    AddToDontRecord(nextRecording);
 
-                    RemoveRecording(nextRecording);
-                    nextRecording = NULL;
-                    recIter = recordingList.begin();
+                    if (recIter == startIter)
+                        startIter++;
                     continue;
                 }
             }
 
-            if (recording && nexttv->isTunerLocked())
+            if (nexttv->isTunerLocked())
             {
-                QString msg = QString("SUPPRESSED recording \"%1\" on channel: "
-                                      "%2 on cardid: %3, sourceid %4. Tuner "
-                                      "is locked by an external application.")
-                                      .arg(nextRecording->title)
-                                      .arg(nextRecording->chanid)
-                                      .arg(nextRecording->cardid)
-                                      .arg(nextRecording->sourceid);
-
+                msg = QString("SUPPRESSED recording \"%1\" on channel: "
+                              "%2 on cardid: %3, sourceid %4. Tuner "
+                              "is locked by an external application.")
+                    .arg(nextRecording->title)
+                    .arg(nextRecording->chanid)
+                    .arg(nextRecording->cardid)
+                    .arg(nextRecording->sourceid);
                 VERBOSE(VB_GENERAL, msg);
 
                 QMutexLocker lockit(recordingList_lock);
-
                 nextRecording->conflicting = false;
                 nextRecording->recording = false;
                 nextRecording->recstatus = rsTunerBusy;
-                AddToDontRecord(nextRecording);
 
-                RemoveRecording(nextRecording);
-                nextRecording = NULL;
-                recIter = recordingList.begin();
+                if (recIter == startIter)
+                    startIter++;
                 continue;
             }
 
-            if ((recording && !nexttv->IsBusyRecording()) || !recording)
+            if (!nexttv->IsBusyRecording())
             {
                 // Will use pre-roll settings only if no other
                 // program is currently being recorded
@@ -1425,83 +1380,58 @@
             //VERBOSE(VB_GENERAL, secsleft << " seconds until " << nextRecording->title);
 
             if (secsleft > 30)
-                break;
+                continue;
 
-            if (recording && secsleft > 2)
+            if (secsleft > 2)
             {
                 QString id = nextRecording->schedulerid;
-
                 if (!recPendingList.contains(id))
                     recPendingList[id] = false;
-
-                if (recPendingList.contains(id) && recPendingList[id] == false)
+                if (recPendingList[id] == false)
                 {
                     nexttv->RecordPending(nextRecording, secsleft);
                     recPendingList[id] = true;
                 }
             }
 
-            if (recording && secsleft <= -2)
-            {
-                QString msg;
-
-                nextRecording->recstartts = 
-                    QDateTime::currentDateTime().addSecs(30);
-                nextRecording->recstartts.setTime(QTime(
-                                   nextRecording->recstartts.time().hour(),
-                                   nextRecording->recstartts.time().minute()));
-
-                QMutexLocker lockit(recordingList_lock);
-
-                int retval = nexttv->StartRecording(nextRecording);
-                if (retval > 0)
-                {
-                    msg = "Started recording";
-                    nextRecording->conflicting = false;
-                    nextRecording->recstatus = rsRecording;
-                }
-                else
-                {
-                    msg = "Canceled recording"; 
-                    nextRecording->conflicting = false;
-                    nextRecording->recording = false;
-                    if (retval < 0)
-                        nextRecording->recstatus = rsTunerBusy;
-                    else
-                        nextRecording->recstatus = rsCancelled;
-                }
-
-                msg += QString(" \"%1\" on channel: %2 on cardid: %3, "
-                               "sourceid %4").arg(nextRecording->title.utf8())
-                                             .arg(nextRecording->chanid)
-                                             .arg(nextRecording->cardid)
-                                             .arg(nextRecording->sourceid);
+            if (secsleft > -2)
+                continue;
 
-                VERBOSE(VB_GENERAL, msg);
+            nextRecording->recstartts = 
+                QDateTime::currentDateTime().addSecs(30);
+            nextRecording->recstartts.setTime(QTime(
+                nextRecording->recstartts.time().hour(),
+                nextRecording->recstartts.time().minute()));
 
-                AddToDontRecord(nextRecording);
+            QMutexLocker lockit(recordingList_lock);
 
-                RemoveRecording(nextRecording);
-                nextRecording = NULL;
-                recIter = recordingList.begin();
-                resetIter = true;
+            int retval = nexttv->StartRecording(nextRecording);
+            if (retval > 0)
+            {
+                msg = "Started recording";
+                nextRecording->conflicting = false;
+                nextRecording->recstatus = rsRecording;
             }
- 
-            if (!recording && secsleft <= -2)
+            else
             {
+                msg = "Canceled recording"; 
                 nextRecording->conflicting = false;
-                AddToDontRecord(nextRecording);
-
-                RemoveRecording(nextRecording);
-                nextRecording = NULL;
-                recIter = recordingList.begin();
-                resetIter = true;
+                nextRecording->recording = false;
+                if (retval < 0)
+                    nextRecording->recstatus = rsTunerBusy;
+                else
+                    nextRecording->recstatus = rsCancelled;
             }
 
-            if (resetIter)
-                resetIter = false;
-            else
-                recIter++;
+            msg += QString(" \"%1\" on channel: %2 on cardid: %3, "
+                           "sourceid %4").arg(nextRecording->title.utf8())
+                .arg(nextRecording->chanid)
+                .arg(nextRecording->cardid)
+                .arg(nextRecording->sourceid);
+            VERBOSE(VB_GENERAL, msg);
+
+            if (recIter == startIter)
+                startIter++;
         }
 
         // if idletimeout is 0, the user disabled the auto-shutdown feature
@@ -1682,8 +1612,9 @@
     return NULL;
 }
 
-void Scheduler::findAllProgramsToRecord(list<ProgramInfo*>& proglist) {
+void Scheduler::AddFuturePrograms(const QDateTime &now) {
     QMap<RecordingType, int> recTypeRecPriorityMap;
+    list<ProgramInfo *> tmpList;
 
     QString query = QString(
 "SELECT DISTINCT channel.chanid, channel.sourceid, "
@@ -1762,101 +1693,121 @@
         .arg(kTimeslotRecord)
         .arg(kWeekslotRecord);
 
-     QSqlQuery result = db->exec(query);
-     QDateTime now = QDateTime::currentDateTime();
+    QSqlQuery result = db->exec(query);
+
+    if (!result.isActive())
+    {
+        MythContext::DBError("AddFuturePrograms", result);
+        return;
+    }
+
+    while (result.next())
+    {
+        ProgramInfo *proginfo = new ProgramInfo;
+        proginfo->recording = true;
+        proginfo->recstatus = rsWillRecord;
+        proginfo->chanid = result.value(0).toString();
+        proginfo->sourceid = result.value(1).toInt();
+        proginfo->startts = result.value(2).toDateTime();
+        proginfo->endts = result.value(3).toDateTime();
+        proginfo->title = QString::fromUtf8(result.value(4).toString());
+        proginfo->subtitle = QString::fromUtf8(result.value(5).toString());
+        proginfo->description = QString::fromUtf8(result.value(6).toString());
+        proginfo->chanstr = result.value(7).toString();
+        proginfo->chansign = result.value(8).toString();
+        proginfo->channame = QString::fromUtf8(result.value(9).toString());
+        proginfo->category = QString::fromUtf8(result.value(11).toString());
+        proginfo->recpriority = result.value(12).toInt();
+        proginfo->dupin = RecordingDupInType(result.value(13).toInt());
+        proginfo->dupmethod =
+            RecordingDupMethodType(result.value(22).toInt());
+        proginfo->rectype = RecordingType(result.value(15).toInt());
+        proginfo->recordid = result.value(16).toInt();
+        proginfo->override = result.value(17).toInt();
+
+        proginfo->recstartts = result.value(18).toDateTime();
+        proginfo->recendts = result.value(19).toDateTime();
+
+        if (!recTypeRecPriorityMap.contains(proginfo->rectype))
+            recTypeRecPriorityMap[proginfo->rectype] = 
+                proginfo->GetRecordingTypeRecPriority(proginfo->rectype);
+        proginfo->recpriority += recTypeRecPriorityMap[proginfo->rectype];
+
+        if (proginfo->recstartts >= proginfo->recendts)
+        {
+            // pre/post-roll are invalid so ignore
+            proginfo->recstartts = proginfo->startts;
+            proginfo->recendts = proginfo->endts;
+        }
+
+        proginfo->repeat = result.value(20).toInt();
+        proginfo->recgroup = result.value(21).toString();
+
+        if (proginfo->override == 2)
+        {
+            proginfo->recording = false;
+            proginfo->recstatus = rsManualOverride;
+        }
+        else if ((proginfo->rectype != kSingleRecord) &&
+                 (proginfo->override != 1) &&
+                 (~proginfo->dupmethod & kDupCheckNone))
+        {
+            if (proginfo->dupin & kDupsInOldRecorded)
+            {
+                if (result.value(10).toInt())
+                {
+                    proginfo->recording = false;
+                    proginfo->recstatus = rsPreviousRecording;
+                }
+            }
+            else if (proginfo->dupin & kDupsInRecorded)
+            {
+                if (result.value(14).toInt())
+                {
+                    proginfo->recording = false;
+                    proginfo->recstatus = rsCurrentRecording;
+                }
+            }
+        }
+
+        proginfo->schedulerid = 
+            proginfo->startts.toString() + "_" + proginfo->chanid;
+
+        // would save many queries to create and populate a
+        // ScheduledRecording and put it in the proginfo at the
+        // same time, since it will be loaded later anyway with
+        // multiple queries
+
+        if (proginfo->title == QString::null)
+            proginfo->title = "";
+        if (proginfo->subtitle == QString::null)
+            proginfo->subtitle = "";
+        if (proginfo->description == QString::null)
+            proginfo->description = "";
+        if (proginfo->category == QString::null)
+            proginfo->category = "";
 
-     if (result.isActive() && result.numRowsAffected() > 0)
-     {
-         while (result.next()) {
-             ProgramInfo *proginfo = new ProgramInfo;
-             proginfo->recording = true;
-             proginfo->recstatus = rsWillRecord;
-             proginfo->chanid = result.value(0).toString();
-             proginfo->sourceid = result.value(1).toInt();
-             proginfo->startts = result.value(2).toDateTime();
-             proginfo->endts = result.value(3).toDateTime();
-             proginfo->title = QString::fromUtf8(result.value(4).toString());
-             proginfo->subtitle = QString::fromUtf8(result.value(5).toString());
-             proginfo->description = QString::fromUtf8(result.value(6).toString());
-             proginfo->chanstr = result.value(7).toString();
-             proginfo->chansign = result.value(8).toString();
-             proginfo->channame = QString::fromUtf8(result.value(9).toString());
-             proginfo->category = QString::fromUtf8(result.value(11).toString());
-             proginfo->recpriority = result.value(12).toInt();
-             proginfo->dupin = RecordingDupInType(result.value(13).toInt());
-             proginfo->dupmethod =
-                 RecordingDupMethodType(result.value(22).toInt());
-             proginfo->rectype = RecordingType(result.value(15).toInt());
-             proginfo->recordid = result.value(16).toInt();
-             proginfo->override = result.value(17).toInt();
-
-             proginfo->recstartts = result.value(18).toDateTime();
-             proginfo->recendts = result.value(19).toDateTime();
-
-             if (!recTypeRecPriorityMap.contains(proginfo->rectype))
-                 recTypeRecPriorityMap[proginfo->rectype] = 
-                     proginfo->GetRecordingTypeRecPriority(proginfo->rectype);
-             proginfo->recpriority += recTypeRecPriorityMap[proginfo->rectype];
-
-             if (proginfo->recstartts >= proginfo->recendts)
-             {
-                 // pre/post-roll are invalid so ignore
-                 proginfo->recstartts = proginfo->startts;
-                 proginfo->recendts = proginfo->endts;
-             }
-
-             proginfo->repeat = result.value(20).toInt();
-             proginfo->recgroup = result.value(21).toString();
-
-             if (proginfo->override == 2)
-             {
-                 proginfo->recording = false;
-                 proginfo->recstatus = rsManualOverride;
-             }
-             else if ((proginfo->rectype != kSingleRecord) &&
-                      (proginfo->override != 1) &&
-                      (~proginfo->dupmethod & kDupCheckNone))
-             {
-                 if (proginfo->dupin & kDupsInOldRecorded)
-                 {
-                     if (result.value(10).toInt())
-                     {
-                         proginfo->recording = false;
-                         proginfo->recstatus = rsPreviousRecording;
-                     }
-                 }
-                 else if (proginfo->dupin & kDupsInRecorded)
-                 {
-                     if (result.value(14).toInt())
-                     {
-                         proginfo->recording = false;
-                         proginfo->recstatus = rsCurrentRecording;
-                     }
-                 }
-             }
-
-             // would save many queries to create and populate a
-             // ScheduledRecording and put it in the proginfo at the
-             // same time, since it will be loaded later anyway with
-             // multiple queries
-
-             if (proginfo->title == QString::null)
-                 proginfo->title = "";
-             if (proginfo->subtitle == QString::null)
-                 proginfo->subtitle = "";
-             if (proginfo->description == QString::null)
-                 proginfo->description = "";
-             if (proginfo->category == QString::null)
-                 proginfo->category = "";
-
-             if (proginfo->recendts < now)
-                 delete proginfo;
-             else 
-                 proglist.push_back(proginfo);
-         }
+        if (proginfo->recendts < now)
+            delete proginfo;
+        else
+        {
+            list<ProgramInfo *>::iterator rec = recordingList.begin();
+            for ( ; rec != recordingList.end(); rec++)
+            {
+                ProgramInfo *r = *rec;
+                if (proginfo->IsSameProgramTimeslot(*r))
+                    break;
+            }
+            if (rec == recordingList.end())
+                tmpList.push_back(proginfo);
+            else
+                delete proginfo;
+        }
     }
-    else if (!result.isActive())
-        MythContext::DBError("findAllProgramsToRecord", result);
+
+    list<ProgramInfo *>::iterator tmp = tmpList.begin();
+    for ( ; tmp != tmpList.end(); tmp++)
+        recordingList.push_back(*tmp);
 }
 
 void Scheduler::findAllScheduledPrograms(list<ProgramInfo*>& proglist)
Index: programs/mythbackend/scheduler.h
===================================================================
RCS file: /var/lib/mythcvs/mythtv/programs/mythbackend/scheduler.h,v
retrieving revision 1.28
diff -u -r1.28 scheduler.h
--- programs/mythbackend/scheduler.h	6 Feb 2004 23:45:05 -0000	1.28
+++ programs/mythbackend/scheduler.h	8 Feb 2004 21:30:45 -0000
@@ -29,8 +29,7 @@
 
     void FillEncoderFreeSpaceCache();
 
-    void AddToDontRecord(ProgramInfo *pginfo);
-    void RemoveRecording(ProgramInfo *pginfo);
+    void UpdateRecStatus(ProgramInfo *pginfo);
 
     list<ProgramInfo *> *getAllPending(void) { return &recordingList; }
     void getAllPending(list<ProgramInfo *> *retList);
@@ -46,7 +45,7 @@
                                         bool removenonplaying = true,
                                         list<ProgramInfo *> *uselist = NULL);
 
-    void PrintList(bool onlyFutureRecordings = false);
+    void PrintList(void);
 
     bool HasConflicts(void) { return hasconflicts; }
 
@@ -59,12 +58,12 @@
   private:
     void setupCards(void);
 
-    void findAllProgramsToRecord(list<ProgramInfo*>& proglist);
+    void AddFuturePrograms(const QDateTime &now);
     void findAllScheduledPrograms(list<ProgramInfo*>& proglist);
     void MarkKnownInputs(void);
     void MarkConflicts(list<ProgramInfo *> *uselist = NULL);
     void PruneOverlaps(void);
-    void PruneList(void);
+    void PruneList(const QDateTime &now);
 
     void MarkConflictsToRemove(void);
     void MarkSingleConflict(ProgramInfo *info,
@@ -72,7 +71,6 @@
 
     void CheckRecPriority(ProgramInfo *info, list<ProgramInfo *> *conflictList);
     void CheckOverride(ProgramInfo *info, list<ProgramInfo *> *conflictList);
-    void RemoveConflicts(void);
     void GuessSingle(ProgramInfo *info, list<ProgramInfo *> *conflictList);
     void GuessConflicts(void);
 
@@ -117,9 +115,7 @@
 
     bool threadrunning;
 
-    void PruneDontRecords(void);
-
-    QValueList<ProgramInfo> dontRecordList;
+    void PruneRecordList(const QDateTime &now);
 
     MainServer *m_mainServer;
 };
